/*
 * Copyright (c) 2008 Marco Neumann
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * */

var misextatvdownload = {
  onLoad: function() {
    // initialization code
    this.initialized = true;
    this.strings = document.getElementById("misextatvdownload-strings");
  },
  onMenuItemCommand: function(e) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);
    promptService.alert(window, this.strings.getString("helloMessageTitle"),
                                this.strings.getString("helloMessage"));
  },
  addVideo: function (name, URL)
	{
			menupopup = document.getElementById("misextatv-statusbar-menupopup");

			var menuitem=menupopup.ownerDocument.createElement("menuitem");
			menuitem.setAttribute('label', name);
			menuitem.setAttribute('oncommand', "misextatvdownload.downloadVideo('"+URL+"')");
			menupopup.appendChild(menuitem);
	},
  downloadVideo: function (httpLoc)
	{
		try {	
			var dlMgr=Components.classes["@mozilla.org/download-manager;1"]
								.getService(Components.interfaces.nsIDownloadManager);
			var dir=dlMgr.userDownloadsDirectory;
			var saveFilePicker=Components.classes["@mozilla.org/filepicker;1"]
		           .createInstance(Components.interfaces.nsIFilePicker);
			saveFilePicker.init(window, "Save", 
				Components.interfaces.nsIFilePicker.modeSave);
			saveFilePicker.displayDirectory=dir;
			saveFilePicker.appendFilter("All Files","*.*");
			
			//Get filename
			var matches = httpLoc.match(/^(.+)(\/)([A-Za-z0-9_%\/\.\-]+\.[flv|mp4]+)/);
			saveFilePicker.defaultString = matches[3];
			
			var rv = saveFilePicker.show();
			if (rv == saveFilePicker.returnOK || rv == saveFilePicker.returnReplace) {
				//dump("Download:\t"+httpLoc+"\t"+saveFilePicker.file.path+"\n");
				var obj_URI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(httpLoc, null, null);
				var obj_TargetFile = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(saveFilePicker.file);
				var obj_Persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
				var dl = dlMgr.addDownload(0, obj_URI, obj_TargetFile, '', null, null, null, obj_Persist);
				obj_Persist.progressListener = {
				                        onLocationChange: function () { dl.onLocationChange.apply(dl, arguments); },
				                        onProgressChange: function () { dl.onProgressChange.apply(dl, arguments); },
				                        onSecurityChange: function () { dl.onSecurityChange.apply(dl, arguments); },
				                        onStatusChange:   function () { dl.onStatusChange.apply(dl, arguments);   },
				                        onStateChange: function (webProgress, request, stateFlags, status) {
				                                dl.onStateChange.apply(dl, arguments);
				                                if ( stateFlags & dl.STATE_STOP ) {
				                                        self.addMetaData(saveFilePicker.file.path, httpLoc);
				                                }
				                        }
				                };
				obj_Persist.saveURI(obj_URI, null, null, null, null, saveFilePicker.file);
			}
		} catch (e) {
			alert(e);
		}
	},
	onClose: function ()
	{
		observerService.removeObserver(reqObserver,"http-on-examine-response");
	},
};
window.addEventListener("load", function(e) { misextatvdownload.onLoad(e); }, false);
window.addEventListener("close", function() { misextatvdownload.onClose(); },true);

/**
 * Capture HTTP Requests
 */
var observerService =
	Components.classes["@mozilla.org/observer-service;1"]
    	.getService(Components.interfaces.nsIObserverService);

/**
 * Donwload Manager
 */
var dm = Components.classes["@mozilla.org/download-manager;1"]
                   .createInstance(Components.interfaces.nsIDownloadManager);

/**
 * TODO - Detect videos with different parts
 * TODO - Detect if video exist
 * TODO - Maximum 10 videos and timeout for 20 min
 */

var reqObserver = {
	observe: function(subject,topic,data) {
		if(topic=="http-on-examine-response") {
			if (typeof Components == 'undefined')
				return;
			
		    var request=subject.QueryInterface(Components.interfaces.nsIRequest);
			/**
			 * Normal video = http://secure-uk.imrworldwide.com/cgi-bin/m?ci=es-lasexta-dav&tl=dav0-Sabemos%20d%F3nde%20fue%20RistoSD&si=rtmp%3A//fl.interoute.com/streamrt/%7Beaf7a24f-6a00-4707-8d5c-56f38f6cb4f1%7D/%7B9bd7cb2d-9140-4ede-86c6-64ab7769252a%7D/9CCFEB3B-E881-4EDB-BB71-4BA841A3F199.flv&cg=misexta-Destacado1-3X3-SD&rp=http%3A//www.misexta.tv&cc=1&rnd=199937609
			 */
			var matches = request.name.match(/^(http:\/\/secure-uk\.imrworldwide\.com\/cgi-bin\/m\?ci=es-lasexta-dav&tl=dav0-)([A-Za-z0-9%\.]+)(SD&si=)(rtmp[A-Za-z0-9_%\/\.\-]+\.flv)(&.+)/);
			//dump("Matches: "+matches+"\n");
			if (matches != null)
			{
				//dump("\t\t ---> "+request.name+"\n");
				misextatvdownload.addVideo(unescape(matches[2]), request.name);//unescape(matches[4]));
				//dump("\t\t ---> Params: "+unescape(matches[2])+"\n");
				//dump("\t\t ---> Params: "+unescape(matches[4])+"\n");
				
			}
			else if (request.name.match(/^http:\/\/dnl\.interoute\.com\/[A-Za-z0-9_%\/\.\-]+\.mp4/))
			{
				/**
				 * HD Video = http://dnl.interoute.com/%7Beaf7a24f-6a00-4707-8d5c-56f38f6cb4f1%7D/%7B9bd7cb2d-9140-4ede-86c6-64ab7769252a%7D/SLQH_23_07_08_02_qtp.mp4
				 */
				//dump("\t\t ---> HD VIDEO: "+request.name+"\n");
				misextatvdownload.addVideo("HD VIDEO", request.name);
			}
			//dump(request.name+"\n");
		}
	}
};

observerService.addObserver(reqObserver,"http-on-examine-response",false);

var misextatvfunctions = {
	saveURL: function (strSource, strDestination)
	{
	    var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
	    aFile.QueryInterface(Components.interfaces.nsILocalFile);
	    aFile.initWithPath(strDestination);

	    try
	    {
	        var source = this.makeURL(strSource);
	        var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
	        const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
	        persist.persistFlags = nsIWBP.PERSIST_FLAGS_NO_CONVERSION | nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_FROM_CACHE;
	        persist.saveURI(source, null, null, null, null, this.makeFileURL(aFile));
	        return true;
	    }
	    catch(e)
	    {alert(e); return false;}
	},

	makeURL: function (aURL)
	{
	  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
	.getService(Components.interfaces.nsIIOService);
	  return ioService.newURI(aURL, null, null);
	},

	makeFileURL: function (aFile)
	{
	  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
	.getService(Components.interfaces.nsIIOService);
	  return ioService.newFileURI(aFile);
	}
};